import { SnapshotRequest } from "homebridge";
import { HomebridgePluginLogging, Nullable } from "homebridge-plugin-utils";
import { ProtectCamera } from "./devices/index.js";
import { ProtectPlatform } from "./protect-platform.js";
export declare class ProtectSnapshot {
    private _cachedSnapshot;
    private readonly api;
    private readonly hap;
    readonly log: HomebridgePluginLogging;
    private readonly nvr;
    readonly platform: ProtectPlatform;
    readonly protectCamera: ProtectCamera;
    constructor(protectCamera: ProtectCamera);
    getSnapshot(request?: SnapshotRequest): Promise<Nullable<Buffer>>;
    private snapFromTimeshift;
    private snapFromRtsp;
    private snapFromFfmpeg;
    private cropSnapshot;
    private get cachedSnapshot();
}
